# Starting the app

You need to run rx-suite modules with 0.0.0.0 as the ip address, so ensure they
can communicate with each other.

In rubymine, this can be done in the run configuration dialog. From the command
line, this can be done with the `-b 0.0.0.0` option.

# Create super user

To create the first user, run `rake super_admin[username,password]`.

This will create a user with the specified username and password, and give the
user permission to access all of the currently setup permissions.

If you add a new module, or if you add a new data store to a module, you will
need to re-run this command to give the super user access to these resources.

# Installation
1. Install Postgres (latest available for your system)  https://www.enterprisedb.com/downloads/postgres-postgresql-downloads
2. Install Ruby+Devkit 2.6.5-1 (x64)  https://rubyinstaller.org/downloads/ (We use features not present in 2.5 and have not yet tested 2.7 for compatibility)
   1.  If the computer has more than one drive, install Ruby to the drive Rx-Suite will be installed to.  
   2.  When the MSYS2 development toolchain installer appears after the main installation is complete, type 3 and hit enter
   
3. Install Bundler with the following command: `gem install bundler`
4. Extract each of the attached zip files to the machine.  Put each into their own directory (the exact location does not matter, but we customarily do c:\sites\hub, c:\sites\rxplore, etc.
5. For each zip, create a file in the root directory called .env (note the period at the start) with contents based off of the .env.sample: 
    ```cmd
         PROD_DATABASE_URL="postgres://[POSTGRES USERNAME]:[POSTGRES PASSWORD]@localhost/[DESIRED DATABASE NAME]" # each module uses a different database
         MODULE_PORT=[DESIRED MODULE PORT] # each module listens on its own port
         RX_HUB_URL=http://[MACHINE IP ADDRESS]:[VALUE OF MODULE_PORT FOR RX_HUB]
    ```
6. For each module, run the following commands with administrator rights:
    ```cmd
        bundle install --local
        set RAILS_ENV=production
        bundle exec rake rx_module:setup
    ```
7. In the Hub module directory, run `bundle exec rake super_admin[desired_username,desired_password]`

    Note that there can't be a space after the comma.  Use the above command format exactly (substituting a username and password for your test user)
8.  There is a new windows service per module.  Start Rx-Hub.  It will take a minute or two before they are ready to respond to requests
9.  Navigate to http://localhost:[RX_HUB PORT] in your browser
10. When the app is responsive, start each other service to complete initial registration

## Development

You will most likely want to set the RX_HUB_IP_ADDRESS environment variable to 127.0.0.1 in development
