import * as React from 'react';
import {LinkButton, useModelContext, useReadonlyContext} from "@rx-suite/ui";
import {CurrentUserModel, CurrentUserStore} from "@rx-suite/stores";
import {t} from "@lingui/macro";
import {RoleFormSubmitButton} from "./RoleFormSubmitButton";


export const RoleFormButton: React.FunctionComponent = () => {
    const model = useModelContext();
    const readOnly = useReadonlyContext();
    const updateLink = model.store.updateLink(model.getId());
    const user = CurrentUserStore.selectedModel as CurrentUserModel;

    const canUpdate = user && model.store.permissionTarget && user.canUpdate(model.store.permissionTarget)

    if (readOnly && updateLink && canUpdate) {
        return <LinkButton to={updateLink} color={"secondary"} noGutter>{t`Edit`}</LinkButton>
    } else {
        return <RoleFormSubmitButton/>
    }

}