import * as React from "react";
import {observer} from "mobx-react-lite";
import {Schedule, ShiftModel} from "../../../stores/ShiftStore";
import {t} from "@lingui/macro";
import {DateField} from "@rx-suite/ui";

export const EndDateField: React.FunctionComponent<{ shift: ShiftModel, schedule: Schedule, scheduleIndex: number, readOnly?: boolean }> = observer(({
                                                                                                                                                         shift,
                                                                                                                                                         schedule,
                                                                                                                                                         scheduleIndex,
                                                                                                                                                         readOnly
                                                                                                                                                     }) => {
    const name = `shift_schedules[${scheduleIndex}].end_date`;
    return (
        <DateField label={t`Until`} value={schedule.end_date} disabled={readOnly}
                   onChange={value => {
                       shift.handleScheduleChange(scheduleIndex, {
                           ...shift.viewModel.shift_schedules[scheduleIndex],
                           end_date: value || null
                       });
                   }}
                   error={shift.errors[name]}
        />
    );
});